;------------------------------------------------------------
; Cdigo assembler generado por Niple V6.0.3
; Proyecto: Frecuencimetro
; Autor: Santiago Riffel
; Fecha: 19/03/2012
; PIC: 16F628A
; Velocidad de reloj: 4 Mhz
; Descripcion: 
;------------------------------------------------------------


 LIST    P=PIC16F628A


_HS_OSC               equ  0x3FEE
_WDT_OFF              equ  0x3FFB
_PWRTE_ON             equ  0x3FF7
_MCLRE_ON             equ  0x3FFF
_BODEN_OFF            equ  0x3FBF
_LVP_OFF              equ  0x3F7F
_CPD_OFF              equ  0x3F7F
_CP_OFF               equ  0x3FFF

 __config _HS_OSC & _WDT_OFF & _PWRTE_ON & _MCLRE_ON & _BODEN_OFF & _LVP_OFF & _CPD_OFF & _CP_OFF


;------------------------------------------------------------
;                  Declaracin de Registros
;------------------------------------------------------------
w                     equ  0x0000
status                equ  0x0003
porta                 equ  0x0005
portb                 equ  0x0006
pclath                equ  0x000a
pir1                  equ  0x000c
tmr1l                 equ  0x000e
tmr1h                 equ  0x000f
t1con                 equ  0x0010
tmr2                  equ  0x0011
t2con                 equ  0x0012
cmcon                 equ  0x001f
_np_temp1             equ  0x0024
_np_nro_lcd           equ  0x0026
_np_msj_act           equ  0x0027
_np_nro_msj           equ  0x0028
_np_lcd_1             equ  0x0029
_np_tiempo            equ  0x002a
_np_tiempo1           equ  0x002c
_np_tiempo2           equ  0x002d
_np_tiempo3           equ  0x002e
contador_l            equ  0x002f
contador_h            equ  0x0030
contador_hh           equ  0x0031
contador_hhh          equ  0x0032
_np_timers            equ  0x0033
_np_frec_prec         equ  0x0034
_np_tmr1_hhh          equ  0x0035
_np_tmr1_hh           equ  0x0036
_np_t2_ini            equ  0x0037
_np_t2_cint_l         equ  0x0038
_np_t2_cint_h         equ  0x0039
_np_t2_cint1_l        equ  0x003a
_np_t2_cint1_h        equ  0x003b
pulsos_uni            equ  0x003c
pulsos_dec            equ  0x003d
pulsos_cen            equ  0x003e
pulsos_u_mil          equ  0x003f
pulsos_d_mil          equ  0x0040
pulsos_c_mil          equ  0x0041
pulsos_u_millon       equ  0x0042
pulsos_d_millon       equ  0x0043
pulsos_c_millon       equ  0x005d
pulsos_m_millon       equ  0x005e
trisa                 equ  0x0085
trisb                 equ  0x0086
pr2                   equ  0x0092
_np_bcd_temp1         equ  0x005f
_np_bcd_temp2         equ  0x0060
_np_bcd_temp3         equ  0x0061
_np_bcd_temp4         equ  0x0062
_np_bcd_temp5         equ  0x0063
_np_bcd_temp6         equ  0x0064
_np_bcd_temp7         equ  0x0065
_np_bcd_temp8         equ  0x0066
_np_bcd_temp9         equ  0x0067
_np_bcd_temp10        equ  0x0068
_np_bcd_temp11        equ  0x0069
_np_bcd_temp12        equ  0x006a
_np_bcd_temp13        equ  0x006b
_np_bcd_temp14        equ  0x006c
_np_bcd_temp15        equ  0x006d
_np_bcd_temp16        equ  0x006e
_np_bcd_temp17        equ  0x006f
_np_bcd_temp18        equ  0x0070
_np_bcd_temp19        equ  0x0071
_np_bcd_temp20        equ  0x0072
_np_bcd_temp21        equ  0x0073
_np_bcd_temp22        equ  0x0074
_np_bcd_temp23        equ  0x0075
_np_bcd_temp24        equ  0x0076
_np_bcd_temp25        equ  0x0077
_np_bcd_temp26        equ  0x0078
_np_bcd_temp27        equ  0x0079


;------------------------------------------------------------
;                  Declaracin de Bits
;------------------------------------------------------------
c                     equ  0   ;carry / borrow bit
ra1                   equ  1   ;bit 1 del puerto a
ra2                   equ  2   ;bit 2 delpuerto a
rp0                   equ  5   ;registrer bank select bit
rp1                   equ  6   ;registrer bank select bit
t1ckps0               equ  4   ;timer 1 input clock prescaler select bit
t1ckps1               equ  5   ;timer 1 input clock prescaler slect bit
t1sync                equ  2   ;timer 1 external clock input synchronization control bit
t2ckps0               equ  0   ;timer 2 clock prescaler select bit
t2ckps1               equ  1   ;timer 2 clock prescaler select bit
tmr1cs                equ  1   ;timer 1 clock source select bit
tmr1if                equ  0   ;bandera de interrupcion por tmr1.
tmr1on                equ  0   ;timer 1 on bit
tmr2if                equ  1   ;bandera de interrupcion por tmr2.
tmr2on                equ  2   ;timer 2 on bit 
to                    equ  4   ;time out bit
toutps0               equ  3   ;timer 2 output postscale select bit
toutps1               equ  4   ;timer 2 output postscale select bit
toutps2               equ  5   ;timer 2 output postscale select bit
toutps3               equ  6   ;timer 2 output postscale select bit
z                     equ  2   ;bit cero
tiempo_t1             equ  1   ;bandera de temporizacion por tmr1
tiempo_t2             equ  2   ;bandera de temporizacion por tmr2


;------------------------------------------------------------
;               Declaracin de Registros EEPROM
;------------------------------------------------------------


;------------------------------------------------------------
;                        Inicio
;------------------------------------------------------------

   org 0x00
   goto paso2


;------------------------------------------------------------
;                      programa principal
;------------------------------------------------------------
paso2
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   clrf _np_temp1
   clrf _np_nro_lcd
   clrf _np_msj_act
   clrf _np_nro_msj
   clrf _np_lcd_1
   clrf _np_tiempo
   clrf _np_tiempo1
   clrf _np_tiempo2
   clrf _np_tiempo3
   clrf contador_l
   clrf contador_h
   clrf contador_hh
   clrf contador_hhh
   clrf _np_timers
   clrf _np_frec_prec
   clrf _np_tmr1_hhh
   clrf _np_tmr1_hh
   clrf _np_t2_ini
   clrf _np_t2_cint_l
   clrf _np_t2_cint_h
   clrf _np_t2_cint1_l
   clrf _np_t2_cint1_h
   clrf pulsos_uni
   clrf pulsos_dec
   clrf pulsos_cen
   clrf pulsos_u_mil
   clrf pulsos_d_mil
   clrf pulsos_c_mil
   clrf pulsos_u_millon
   clrf pulsos_d_millon
   clrf pulsos_c_millon
   clrf pulsos_m_millon
   clrf _np_bcd_temp1
   clrf _np_bcd_temp2
   clrf _np_bcd_temp3
   clrf _np_bcd_temp4
   clrf _np_bcd_temp5
   clrf _np_bcd_temp6
   clrf _np_bcd_temp7
   clrf _np_bcd_temp8
   clrf _np_bcd_temp9
   clrf _np_bcd_temp10
   clrf _np_bcd_temp11
   clrf _np_bcd_temp12
   clrf _np_bcd_temp13
   clrf _np_bcd_temp14
   clrf _np_bcd_temp15
   clrf _np_bcd_temp16
   clrf _np_bcd_temp17
   clrf _np_bcd_temp18
   clrf _np_bcd_temp19
   clrf _np_bcd_temp20
   clrf _np_bcd_temp21
   clrf _np_bcd_temp22
   clrf _np_bcd_temp23
   clrf _np_bcd_temp24
   clrf _np_bcd_temp25
   clrf _np_bcd_temp26
   clrf _np_bcd_temp27
   clrf porta
   movlw b'00000000'                ;configurar el puerto a como xxxsssss
   bsf status,rp0                   ;cambiar a banco 1
   movwf trisa
   movlw b'00000111'                ;puerto a = e/s digital
   bcf status,rp0                   ;cambiar a banco 0
   movwf cmcon
   clrf portb
   movlw b'01000000'                ;configurar el puerto b como sessssss
   bsf status,rp0                   ;cambiar a banco 1
   movwf trisb
   bcf status,rp0                   ;cambiar a banco 0
   bsf porta,ra1
   bsf porta,ra2
   movlw b'00000001'
   movwf _np_nro_lcd
   call lcd_inicio                  ;llamada a rutina lcd_inicio
paso7
   bcf t1con,tmr1on
   bcf t2con,tmr2on
   bsf t1con,tmr1cs
   bsf t1con,t1sync
   bcf t1con,t1ckps0
   bcf t1con,t1ckps1
   bcf t2con,toutps0
   bcf t2con,toutps1
   bcf t2con,toutps2
   bcf t2con,toutps3
   bcf t2con,t2ckps0
   bsf t2con,t2ckps1
   clrf tmr2
   movlw .249
   bsf status,rp0                   ;cambiar a banco 1
   movwf pr2
   bcf status,rp0                   ;cambiar a banco 0
   clrf _np_t2_cint_h
   clrf _np_t2_cint1_h
   movlw b'01111101'
   movwf _np_t2_cint_l
   movwf _np_t2_cint1_l
   clrf tmr1h
   clrf tmr1l
   clrf _np_tmr1_hhh
   clrf _np_tmr1_hh
   clrf contador_hhh
   clrf contador_hh
   clrf contador_h
   clrf contador_l
   bcf pir1,tmr1if
   bcf pir1,tmr2if
   bsf t2con,tmr2on
   bsf t1con,tmr1on
paso7_d
   btfss pir1,tmr2if
   goto paso7_f
   decfsz _np_t2_cint_l,1
   goto paso7_e
   movf _np_t2_cint_h,w
   btfsc status,z
   goto paso7_g
   decf _np_t2_cint_h,1
   goto paso7_f
   bcf pir1,tmr2if
   goto paso7_g
paso7_e
   bcf pir1,tmr2if
paso7_f
   btfss pir1,tmr1if
   goto paso7_d
   incf _np_tmr1_hh,1
   btfsc status,z
   incf _np_tmr1_hhh,1
   bcf pir1,tmr1if
   goto paso7_d
paso7_g
   bcf t1con,tmr1on
   bcf t2con,tmr2on
   movf _np_tmr1_hhh,w
   movwf contador_hhh
   movf _np_tmr1_hh,w
   movwf contador_hh
   movf tmr1h,w
   movwf contador_h
   movf tmr1l,w
   movwf contador_l
   bcf status,c
   rlf contador_l,1
   rlf contador_h,1
   rlf contador_hh,1
   rlf contador_hhh,1
   call rutusr_002                  ;llamada a rutina usr_lcd_pantalla_2
   goto paso7                       ;cierra el ciclo


;------------------------------------------------------------
;                  Declaracin de Subrutinas
;------------------------------------------------------------

; usr_lcd_pantalla_2
rutusr_002
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf contador_l,w                ;conversion a bcd
   movwf _np_bcd_temp1
   movf contador_h,w
   movwf _np_bcd_temp2
   movf contador_hh,w
   movwf _np_bcd_temp3
   movf contador_hhh,w
   movwf _np_bcd_temp4
   call dec_bcd_32                  ;llamada a rutina dec_bcd_32
   movf _np_bcd_temp5,w
   movwf pulsos_uni
   movf _np_bcd_temp6,w
   movwf pulsos_dec
   movf _np_bcd_temp7,w
   movwf pulsos_cen
   movf _np_bcd_temp8,w
   movwf pulsos_u_mil
   movf _np_bcd_temp9,w
   movwf pulsos_d_mil
   movf _np_bcd_temp10,w
   movwf pulsos_c_mil
   movf _np_bcd_temp11,w
   movwf pulsos_u_millon
   movf _np_bcd_temp12,w
   movwf pulsos_d_millon
   movf _np_bcd_temp13,w
   movwf pulsos_c_millon
   movf _np_bcd_temp14,w
   movwf pulsos_m_millon
   movlw .2
   movwf _np_nro_msj
   call lcd_mensaje_actual          ;llamada a rutina lcd_mensaje_actual
   btfss _np_msj_act,0
   goto rutusr_002_3_nc
   movlw b'00001100'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movlw b'00000001'
   call lcd_comando                 ;llamada a rutina lcd_comando
rutusr_002_3_nc
   movlw b'10000000'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movlw .70                        ;f
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .114                       ;r
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .101                       ;e
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .99                        ;c
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .117                       ;u
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .101                       ;e
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .110                       ;n
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .99                        ;c
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .105                       ;i
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .97                        ;a
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .58                        ;:
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'10001101'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movlw .77                        ;m
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .72                        ;h
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .122                       ;z
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'11000101'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movlw .75                        ;k
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .72                        ;h
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .122                       ;z
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .32                        ;espacio
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'11001100'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movlw .72                        ;h
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw .122                       ;z
   call lcd_caracter                ;llamada a rutina lcd_caracter
rutusr_002_3_var
   movlw b'10001011'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movf pulsos_d_millon,w           ;enviar la variable pulsos_d_millon al lcd.
   addlw .48
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'10001100'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movf pulsos_u_millon,w           ;enviar la variable pulsos_u_millon al lcd.
   addlw .48
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'11000010'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movf pulsos_c_mil,w              ;enviar la variable pulsos_c_mil al lcd.
   addlw .48
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'11000011'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movf pulsos_d_mil,w              ;enviar la variable pulsos_d_mil al lcd.
   addlw .48
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'11000100'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movf pulsos_u_mil,w              ;enviar la variable pulsos_u_mil al lcd.
   addlw .48
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'11001001'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movf pulsos_cen,w                ;enviar la variable pulsos_cen al lcd.
   addlw .48
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'11001010'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movf pulsos_dec,w                ;enviar la variable pulsos_dec al lcd.
   addlw .48
   call lcd_caracter                ;llamada a rutina lcd_caracter
   movlw b'11001011'
   call lcd_comando                 ;llamada a rutina lcd_comando
   movf pulsos_uni,w                ;enviar la variable pulsos_uni al lcd.
   addlw .48
   call lcd_caracter                ;llamada a rutina lcd_caracter
rutusr_002_4
   goto rutusr_002_salir
rutusr_002_salir
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   return


lcd_inicio
   movlw b'00000001'
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movwf _np_nro_lcd
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   clrf _np_nro_msj
   movlw .2                         ;temporizador 20 ms
   call tmp_100_mc                  ;llamada a rutina tmp_100_mc
   movlw b'00110000'
   call lcd_comando_ini             ;llamada a rutina lcd_comando_ini
   movlw .2                         ;temporizador 20 ms
   call tmp_100_mc                  ;llamada a rutina tmp_100_mc
   movlw b'00110000'
   call lcd_comando_ini             ;llamada a rutina lcd_comando_ini
   movlw .1                         ;temporizador 1 ms
   call tmp_1_mc                    ;llamada a rutina tmp_1_mc
   movlw b'00110000'
   call lcd_comando_ini             ;llamada a rutina lcd_comando_ini
   movlw b'00100000'
   call lcd_comando_ini             ;llamada a rutina lcd_comando_ini
   movlw b'00100000'
   call lcd_comando_ini             ;llamada a rutina lcd_comando_ini
   movlw b'10000000'
   call lcd_comando_ini             ;llamada a rutina lcd_comando_ini
   return
lcd_busy
   movlw .2                         ;temporizador 2 ms
   call tmp_1_mc                    ;llamada a rutina tmp_1_mc
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   return
lcd_comando_ini
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movwf _np_temp1
   bcf portb,0
   goto lcd_enviar_ini
lcd_comando
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movwf _np_temp1
   bcf portb,0
   goto lcd_enviar
lcd_caracter
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movwf _np_temp1
   bsf portb,0
lcd_enviar
   bsf portb,1
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movwf _np_temp1
   bcf portb,2
   bcf portb,3
   bcf portb,4
   bcf portb,5
   btfsc _np_temp1,4
   bsf portb,2
   btfsc _np_temp1,5
   bsf portb,3
   btfsc _np_temp1,6
   bsf portb,4
   btfsc _np_temp1,7
   bsf portb,5
   bcf portb,1
   nop
   nop
   bsf portb,1
   bcf portb,2
   bcf portb,3
   bcf portb,4
   bcf portb,5
   btfsc _np_temp1,0
   bsf portb,2
   btfsc _np_temp1,1
   bsf portb,3
   btfsc _np_temp1,2
   bsf portb,4
   btfsc _np_temp1,3
   bsf portb,5
   bcf portb,1
   nop
   nop
   bsf portb,1
   call lcd_busy                    ;llamada a rutina lcd_busy
   return
lcd_enviar_ini
   bsf portb,1
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movwf _np_temp1
   bcf portb,2
   bcf portb,3
   bcf portb,4
   bcf portb,5
   btfsc _np_temp1,4
   bsf portb,2
   btfsc _np_temp1,5
   bsf portb,3
   btfsc _np_temp1,6
   bsf portb,4
   btfsc _np_temp1,7
   bsf portb,5
   bcf portb,1
   nop
   nop
   bsf portb,1
   call lcd_busy                    ;llamada a rutina lcd_busy
   return
lcd_mensaje_actual
lcd_1
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   clrf _np_msj_act
   movf _np_nro_msj,w
   xorwf _np_lcd_1,w
   btfss status,z
   bsf _np_msj_act,0
   movf _np_nro_msj,w
   movwf _np_lcd_1
   return

dec_bcd_32
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   clrf _np_bcd_temp14
   clrf _np_bcd_temp13
   clrf _np_bcd_temp12
   clrf _np_bcd_temp11
   clrf _np_bcd_temp10
   clrf _np_bcd_temp9
   clrf _np_bcd_temp8
   clrf _np_bcd_temp7
   clrf _np_bcd_temp6
   clrf _np_bcd_temp5
   clrf _np_bcd_temp26
   clrf _np_bcd_temp25
   clrf _np_bcd_temp24
   clrf _np_bcd_temp23
   clrf _np_bcd_temp22
   clrf _np_bcd_temp21
   clrf _np_bcd_temp20
   clrf _np_bcd_temp19
   clrf _np_bcd_temp18
   clrf _np_bcd_temp17
   incf _np_bcd_temp17,1
   movlw .32
   movwf _np_bcd_temp16
dec_bcd_32_rot
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   btfss _np_bcd_temp1,0
   goto dec_bcd_32_n_s
   call dec_bcd_32_s                ;llamada a rutina dec_bcd_32_s
dec_bcd_32_n_s
   call dec_bcd_32_r_d              ;llamada a rutina dec_bcd_32_r_d
   bcf status,c
   rrf _np_bcd_temp4,1
   rrf _np_bcd_temp3,1
   rrf _np_bcd_temp2,1
   rrf _np_bcd_temp1,1
   decfsz _np_bcd_temp16,1
   goto dec_bcd_32_rot
   return
dec_bcd_32_s
   call dec_bcd_32_s_1              ;llamada a rutina dec_bcd_32_s_1
   call dec_bcd_32_s_2              ;llamada a rutina dec_bcd_32_s_2
   call dec_bcd_32_s_3              ;llamada a rutina dec_bcd_32_s_3
   call dec_bcd_32_s_4              ;llamada a rutina dec_bcd_32_s_4
   call dec_bcd_32_s_5              ;llamada a rutina dec_bcd_32_s_5
   call dec_bcd_32_s_6              ;llamada a rutina dec_bcd_32_s_6
   call dec_bcd_32_s_7              ;llamada a rutina dec_bcd_32_s_7
   call dec_bcd_32_s_8              ;llamada a rutina dec_bcd_32_s_8
   call dec_bcd_32_s_9              ;llamada a rutina dec_bcd_32_s_9
   call dec_bcd_32_s_10             ;llamada a rutina dec_bcd_32_s_10
   return
dec_bcd_32_s_1
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp17,w
   addwf _np_bcd_temp5,1
   movf _np_bcd_temp5,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp5,1
   incf _np_bcd_temp6,1
   return
dec_bcd_32_s_2
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp18,w
   addwf _np_bcd_temp6,1
   movf _np_bcd_temp6,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp6,1
   incf _np_bcd_temp7,1
   return
dec_bcd_32_s_3
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp19,w
   addwf _np_bcd_temp7,1
   movf _np_bcd_temp7,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp7,1
   incf _np_bcd_temp8,1
   return
dec_bcd_32_s_4
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp20,w
   addwf _np_bcd_temp8,1
   movf _np_bcd_temp8,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp8,1
   incf _np_bcd_temp9,1
   return
dec_bcd_32_s_5
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp21,w
   addwf _np_bcd_temp9,1
   movf _np_bcd_temp9,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp9,1
   incf _np_bcd_temp10,1
   return
dec_bcd_32_s_6
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp22,w
   addwf _np_bcd_temp10,1
   movf _np_bcd_temp10,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp10,1
   incf _np_bcd_temp11,1
   return
dec_bcd_32_s_7
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp23,w
   addwf _np_bcd_temp11,1
   movf _np_bcd_temp11,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp11,1
   incf _np_bcd_temp12,1
   return
dec_bcd_32_s_8
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp24,w
   addwf _np_bcd_temp12,1
   movf _np_bcd_temp12,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp12,1
   incf _np_bcd_temp13,1
   return
dec_bcd_32_s_9
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp25,w
   addwf _np_bcd_temp13,1
   movf _np_bcd_temp13,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp13,1
   incf _np_bcd_temp14,1
   return
dec_bcd_32_s_10
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp26,w
   addwf _np_bcd_temp14,1
   movf _np_bcd_temp14,w
   sublw .9
   btfsc status,c
   return
   movlw .10
   subwf _np_bcd_temp14,1
   return
dec_bcd_32_r_d
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   clrf _np_bcd_temp27
dec_bcd_32_d1
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp17,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp17
dec_bcd_32_d2
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp18,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp18
dec_bcd_32_d3
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp19,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp19
dec_bcd_32_d4
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp20,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp20
dec_bcd_32_d5
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp21,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp21
dec_bcd_32_d6
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp22,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp22
dec_bcd_32_d7
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp23,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp23
dec_bcd_32_d8
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp24,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp24
dec_bcd_32_d9
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp25,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp25
dec_bcd_32_d10
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movf _np_bcd_temp26,w
   movwf _np_bcd_temp15
   call dec_bcd_32_d                ;llamada a rutina dec_bcd_32_d
   movf _np_bcd_temp15,w
   movwf _np_bcd_temp26
   return
dec_bcd_32_d
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   bcf status,c
   rlf _np_bcd_temp15,1
   movf _np_bcd_temp27,w
   btfss status,z
   incf _np_bcd_temp15,1
   movf _np_bcd_temp15,w
   btfsc status,z
   return
   sublw .9
   btfss status,c
   goto dec_bcd_32_d_m
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   clrf _np_bcd_temp27
   return
dec_bcd_32_d_m
   movlw .10
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   subwf _np_bcd_temp15,1
   incf _np_bcd_temp27,1
   return

tmp_100_mc
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movwf _np_tiempo
   goto tmp_100_mc_1
tmp_100_mc_bucle2
   nop
   nop
   nop
   nop
   nop
   nop
   nop
tmp_100_mc_1
   movlw .22
   movwf _np_tiempo1
tmp_100_mc_bucle1
   movlw .150
   movwf _np_tiempo2
tmp_100_mc_bucle
   decfsz _np_tiempo2,1
   goto tmp_100_mc_bucle
   decfsz _np_tiempo1,1
   goto tmp_100_mc_bucle1
   nop
   decfsz _np_tiempo,1
   goto tmp_100_mc_bucle2
   return


tmp_1_mc
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movwf _np_tiempo
   goto tmp_1_mc_1
tmp_1_mc_bucle1
   nop
   nop
   nop
   nop
   nop
   nop
   nop
tmp_1_mc_1
   movlw .246
   movwf _np_tiempo1
tmp_1_mc_bucle2
   nop
   decfsz _np_tiempo1,1
   goto tmp_1_mc_bucle2
   nop
   nop
   nop
   nop
   nop
   decfsz _np_tiempo,1
   goto tmp_1_mc_bucle1
   return



;------------------------------------------------------------
;                  DATOS EN MEMORIA EEPROM
;------------------------------------------------------------
   org  0x2100
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff

 End